Index: /trunk/LMDZ.COMMON/libf/evolution/pemetat0.F90
===================================================================
--- /trunk/LMDZ.COMMON/libf/evolution/pemetat0.F90	(revision 3075)
+++ /trunk/LMDZ.COMMON/libf/evolution/pemetat0.F90	(revision 3076)
@@ -1,15 +1,26 @@
-SUBROUTINE pemetat0(filename,ngrid,nsoil_GCM,nsoil_PEM,nslope,timelen,timestep,TI_PEM,tsoil_PEM,ice_table, ice_table_thickness, &
-                      tsurf_ave_yr1,tsurf_ave_yr2,q_co2,q_h2o,ps_inst,tsoil_inst,tend_h2oglaciers,tend_co2glaciers,co2ice,waterice, &
-                      global_ave_pressure,watersurf_ave,watersoil_ave, m_co2_regolith_phys,deltam_co2_regolith_phys,  &
-                      m_h2o_regolith_phys,deltam_h2o_regolith_phys, water_reservoir)
-   
-  use iostart_PEM,                only: open_startphy, close_startphy, get_field, get_var
-  use comsoil_h_PEM,              only: soil_pem, layer_PEM, mlayer_PEM, fluxgeo, inertiedat_PEM, water_reservoir_nom, depth_breccia, depth_bedrock, index_breccia, index_bedrock
-  use comsoil_h,                  only: volcapa,inertiedat 
-  use adsorption_mod,             only: regolith_adsorption, adsorption_pem
-  use ice_table_mod,              only: computeice_table_equilibrium
-  use constants_marspem_mod,      only: alpha_clap_h2o, beta_clap_h2o, TI_breccia, TI_bedrock
-  use soil_thermalproperties_mod, only: update_soil_thermalproperties
-  use tracer_mod,                 only: mmol, igcm_h2o_vap ! tracer names and molar masses
+MODULE pemetat0_mod
+
+implicit none
+
+!=======================================================================
+contains
+!=======================================================================
+
+SUBROUTINE pemetat0(filename,ngrid,nsoil_GCM,nsoil_PEM,nslope,timelen,timestep,TI_PEM,tsoil_PEM,ice_table, ice_table_thickness,   &
+                    tsurf_ave_yr1,tsurf_ave_yr2,q_co2,q_h2o,ps_inst,tsoil_inst,tend_h2oglaciers,tend_co2glaciers,co2ice,waterice, &
+                    global_ave_pressure,watersurf_ave,watersoil_ave, m_co2_regolith_phys,deltam_co2_regolith_phys,                &
+                    m_h2o_regolith_phys,deltam_h2o_regolith_phys, water_reservoir)
+
+use iostart_PEM,                only: open_startphy, close_startphy, get_field, get_var
+use comsoil_h_PEM,              only: soil_pem, layer_PEM, mlayer_PEM, fluxgeo, inertiedat_PEM, water_reservoir_nom, depth_breccia, depth_bedrock, index_breccia, index_bedrock
+use comsoil_h,                  only: volcapa,inertiedat
+use adsorption_mod,             only: regolith_adsorption, adsorption_pem
+use ice_table_mod,              only: computeice_table_equilibrium
+use constants_marspem_mod,      only: alpha_clap_h2o, beta_clap_h2o, TI_breccia, TI_bedrock
+use soil_thermalproperties_mod, only: update_soil_thermalproperties
+use tracer_mod,                 only: mmol, igcm_h2o_vap ! tracer names and molar masses
+use abort_pem_mod,              only: abort_pem
+use soil_pem_compute_mod,       only: soil_pem_compute
+use soil_pem_ini_mod,           only: soil_pem_ini
 
 #ifndef CPP_STD
@@ -20,58 +31,57 @@
 #endif
 
-  implicit none
-
-  include "callkeys.h"
-
-  character(len=*), intent(in) :: filename                    ! name of the startfi_PEM.nc
-  integer,intent(in) :: ngrid                                 ! # of physical grid points
-  integer,intent(in) :: nsoil_GCM                             ! # of vertical grid points in the GCM
-  integer,intent(in) :: nsoil_PEM                             ! # of vertical grid points in the PEM
-  integer,intent(in) :: nslope                                ! # of sub-grid slopes
-  integer,intent(in) :: timelen                               ! # time samples
-  real, intent(in) :: tsurf_ave_yr1(ngrid,nslope)             ! surface temperature at the first year of GCM call [K]
-  real,intent(in) :: tsurf_ave_yr2(ngrid,nslope)              ! surface temperature at the second  year of GCM call [K]
-  real,intent(in) :: q_co2(ngrid,timelen)                     ! MMR tracer co2 [kg/kg]
-  real,intent(in) :: q_h2o(ngrid,timelen)                     ! MMR tracer h2o [kg/kg]
-  real,intent(in) :: ps_inst(ngrid,timelen)                   ! surface pressure [Pa]
-  real,intent(in) :: timestep                                 ! time step [s]
-  real,intent(in) :: tend_h2oglaciers(ngrid,nslope)           ! tendencies on h2o glaciers 
-  real,intent(in) :: tend_co2glaciers(ngrid,nslope)           ! tendencies on co2 glaciers
-  real,intent(in) :: co2ice(ngrid,nslope)                     ! co2 ice amount [kg/m^2]
-  real,intent(in) :: waterice(ngrid,nslope)                   ! water ice amount [kg/m^2]
-  real, intent(in) :: watersurf_ave(ngrid,nslope)             ! surface water ice density, yearly averaged  (kg/m^3)
-  real, intent(inout) :: watersoil_ave(ngrid,nsoil_PEM,nslope)! surface water ice density, yearly averaged (kg/m^3)
-  real, intent(in) :: global_ave_pressure                     ! mean average pressure on the planet [Pa]
+implicit none
+
+include "callkeys.h"
+
+character(len=*),               intent(in) :: filename            ! name of the startfi_PEM.nc
+integer,                        intent(in) :: ngrid               ! # of physical grid points
+integer,                        intent(in) :: nsoil_GCM           ! # of vertical grid points in the GCM
+integer,                        intent(in) :: nsoil_PEM           ! # of vertical grid points in the PEM
+integer,                        intent(in) :: nslope              ! # of sub-grid slopes
+integer,                        intent(in) :: timelen             ! # time samples
+real,                           intent(in) :: timestep            ! time step [s]
+real,                           intent(in) :: global_ave_pressure ! mean average pressure on the planet [Pa]
+real, dimension(ngrid,nslope),  intent(in) :: tsurf_ave_yr1       ! surface temperature at the first year of GCM call [K]
+real, dimension(ngrid,nslope),  intent(in) :: tsurf_ave_yr2       ! surface temperature at the second  year of GCM call [K]
+real, dimension(ngrid,timelen), intent(in) :: q_co2               ! MMR tracer co2 [kg/kg]
+real, dimension(ngrid,timelen), intent(in) :: q_h2o               ! MMR tracer h2o [kg/kg]
+real, dimension(ngrid,timelen), intent(in) :: ps_inst             ! surface pressure [Pa]
+real, dimension(ngrid,nslope),  intent(in) :: tend_h2oglaciers    ! tendencies on h2o glaciers
+real, dimension(ngrid,nslope),  intent(in) :: tend_co2glaciers    ! tendencies on co2 glaciers
+real, dimension(ngrid,nslope),  intent(in) :: co2ice              ! co2 ice amount [kg/m^2]
+real, dimension(ngrid,nslope),  intent(in) :: waterice            ! water ice amount [kg/m^2]
+real, dimension(ngrid,nslope),  intent(in) :: watersurf_ave       ! surface water ice density, yearly averaged  (kg/m^3)
 ! outputs
-
-  real,intent(inout) :: TI_PEM(ngrid,nsoil_PEM,nslope)                ! soil (mid-layer) thermal inertia in the PEM grid [SI]
-  real,intent(inout) :: tsoil_PEM(ngrid,nsoil_PEM,nslope)             ! soil (mid-layer) temperature [K]
-  real,intent(inout) :: ice_table(ngrid,nslope)                       ! Ice table depth [m]
-  real,intent(inout) :: ice_table_thickness(ngrid,nslope)             ! Ice table thickness [m]
-  real,intent(inout) :: tsoil_inst(ngrid,nsoil_PEM,nslope,timelen)    ! instantaneous soil (mid-layer) temperature [K]
-  real,intent(inout) :: m_co2_regolith_phys(ngrid,nsoil_PEM,nslope)   ! mass of co2 adsorbed [kg/m^2]
-  real,intent(out) :: deltam_co2_regolith_phys(ngrid)                 ! mass of co2 that is exchanged due to adsorption desorption [kg/m^2]
-  real,intent(inout) :: m_h2o_regolith_phys(ngrid,nsoil_PEM,nslope)   ! mass of h2o adsorbed [kg/m^2]
-  real,intent(out) :: deltam_h2o_regolith_phys(ngrid)                 ! mass of h2o that is exchanged due to adsorption desorption [kg/m^2]
-  real,intent(inout) :: water_reservoir(ngrid)                        ! mass of h2o that is exchanged due to adsorption desorption [kg/m^2]
+real, dimension(ngrid),                          intent(out) :: deltam_co2_regolith_phys ! mass of co2 that is exchanged due to adsorption desorption [kg/m^2]
+real, dimension(ngrid),                          intent(out) :: deltam_h2o_regolith_phys ! mass of h2o that is exchanged due to adsorption desorption [kg/m^2]
+real, dimension(ngrid,nsoil_PEM,nslope),         intent(inout) :: TI_PEM              ! soil (mid-layer) thermal inertia in the PEM grid [SI]
+real, dimension(ngrid,nsoil_PEM,nslope),         intent(inout) :: tsoil_PEM           ! soil (mid-layer) temperature [K]
+real, dimension(ngrid,nslope),                   intent(inout) :: ice_table           ! Ice table depth [m]
+real, dimension(ngrid,nslope),                   intent(inout) :: ice_table_thickness ! Ice table thickness [m]
+real, dimension(ngrid,nsoil_PEM,nslope,timelen), intent(inout) :: tsoil_inst          ! instantaneous soil (mid-layer) temperature [K]
+real, dimension(ngrid,nsoil_PEM,nslope),         intent(inout) :: m_co2_regolith_phys ! mass of co2 adsorbed [kg/m^2]
+real, dimension(ngrid,nsoil_PEM,nslope),         intent(inout) :: m_h2o_regolith_phys ! mass of h2o adsorbed [kg/m^2]
+real, dimension(ngrid),                          intent(inout) :: water_reservoir     ! mass of h2o that is exchanged due to adsorption desorption [kg/m^2]
+real, dimension(ngrid,nsoil_PEM,nslope),         intent(inout) :: watersoil_ave       ! surface water ice density, yearly averaged (kg/m^3)
 ! local
-   real :: tsoil_startPEM(ngrid,nsoil_PEM,nslope)                     ! soil temperature saved in the start [K]
-   real :: TI_startPEM(ngrid,nsoil_PEM,nslope)                        ! soil thermal inertia saved in the start [SI]
-   LOGICAL :: found                                                   ! check if variables are found in the start
-   LOGICAL :: found2                                                  ! check if variables are found in the start
-   integer :: iloop,ig,islope,it,isoil                                ! index for loops
-   real :: kcond                                                      ! Thermal conductivity, intermediate variable [SI]
-   real :: delta                                                      ! Depth of the interface regolith-breccia, breccia -bedrock [m]
-   CHARACTER*2 :: num                                                 ! intermediate string to read PEM start sloped variables
-   real :: tsoil_saved(ngrid,nsoil_PEM)                               ! saved soil temperature [K]
-   real :: tsoil_tmp_yr1(ngrid,nsoil_PEM,nslope)                      ! intermediate soil temperature during yr1[K]
-   real :: tsoil_tmp_yr2(ngrid,nsoil_PEM,nslope)                      ! intermediate soil temperature during yr 2 [K]
-   real :: alph_tmp(ngrid,nsoil_PEM-1)                                ! Intermediate for tsoil computation []
-   real :: beta_tmp(ngrid,nsoil_PEM-1)                                ! Intermediate for tsoil computatio []                               
-   LOGICAL :: startpem_file                                           ! boolean to check if we read the startfile or not
-#ifdef CPP_STD   
-   logical :: watercaptag(ngrid)
-
-   watercaptag(:)=.false.
+real, dimension(ngrid,nsoil_PEM,nslope) :: tsoil_startPEM               ! soil temperature saved in the start [K]
+real, dimension(ngrid,nsoil_PEM,nslope) :: TI_startPEM                  ! soil thermal inertia saved in the start [SI]
+logical                                 :: found                        ! check if variables are found in the start
+logical                                 :: found2                       ! check if variables are found in the start
+integer                                 :: iloop, ig, islope, it, isoil ! index for loops
+real                                    :: kcond                        ! Thermal conductivity, intermediate variable [SI]
+real                                    :: delta                        ! Depth of the interface regolith-breccia, breccia -bedrock [m]
+character(2)                            :: num                          ! intermediate string to read PEM start sloped variables
+real, dimension(ngrid,nsoil_PEM)        :: tsoil_saved                  ! saved soil temperature [K]
+real, dimension(ngrid,nsoil_PEM,nslope) :: tsoil_tmp_yr1                ! intermediate soil temperature during yr1[K]
+real, dimension(ngrid,nsoil_PEM,nslope) :: tsoil_tmp_yr2                ! intermediate soil temperature during yr 2 [K]
+real, dimension(ngrid,nsoil_PEM - 1)    :: alph_tmp                     ! Intermediate for tsoil computation []
+real, dimension(ngrid,nsoil_PEM - 1)    :: beta_tmp                     ! Intermediate for tsoil computatio []
+logical                                 :: startpem_file                ! boolean to check if we read the startfile or not
+
+#ifdef CPP_STD
+   logical, dimension(ngrid) :: watercaptag
+   watercaptag(:) = .false.
 #endif
 
@@ -81,5 +91,5 @@
 !!!
 !!! Order: 0. Previous year of the PEM run
-!!!        1. Thermal Inertia 
+!!!        1. Thermal Inertia
 !!!        2. Soil Temperature
 !!!        3. Ice table
@@ -99,53 +109,51 @@
 
 !1. Run
-
 if (startpem_file) then
-   ! open pem initial state file:
-   call open_startphy(filename)
+    ! open pem initial state file:
+    call open_startphy(filename)
 
     if (soil_pem) then
- 
+
 !1. Thermal Inertia
 ! a. General case
-
-DO islope=1,nslope
-  write(num,fmt='(i2.2)') islope
-  call get_field("TI_PEM_slope"//num,TI_startPEM(:,:,islope),found)
-   if(.not.found) then
-      write(*,*)'PEM settings: failed loading <TI_PEM_slope'//num//'>'
-      write(*,*)'will reconstruct the values of TI_PEM'
-
-      do ig = 1,ngrid
-          if(TI_PEM(ig,index_breccia,islope).lt.TI_breccia) then 
-!!! transition
-             delta = depth_breccia
-             TI_PEM(ig,index_breccia+1,islope) = sqrt((layer_PEM(index_breccia+1)-layer_PEM(index_breccia))/ &
-            (((delta-layer_PEM(index_breccia))/(TI_PEM(ig,index_breccia,islope)**2))+ &
-                      ((layer_PEM(index_breccia+1)-delta)/(TI_breccia**2))))
-            do iloop=index_breccia+2,index_bedrock
-              TI_PEM(ig,iloop,islope) = TI_breccia
-            enddo      
-          else ! we keep the high ti values
-            do iloop=index_breccia+1,index_bedrock
-              TI_PEM(ig,iloop,islope) = TI_PEM(ig,index_breccia,islope)
-            enddo 
-          endif ! TI PEM and breccia comparison
-!! transition
-          delta = depth_bedrock
-          TI_PEM(ig,index_bedrock+1,islope) = sqrt((layer_PEM(index_bedrock+1)-layer_PEM(index_bedrock))/ &
-               (((delta-layer_PEM(index_bedrock))/(TI_PEM(ig,index_bedrock,islope)**2))+ &
-               ((layer_PEM(index_bedrock+1)-delta)/(TI_bedrock**2))))
-          do iloop=index_bedrock+2,nsoil_PEM
-            TI_PEM(ig,iloop,islope) = TI_bedrock
-          enddo   
-      enddo
-   else ! found
-     do iloop = nsoil_GCM+1,nsoil_PEM
-       TI_PEM(:,iloop,islope) = TI_startPEM(:,iloop,islope)  ! ! 1st layers can change because of the presence of ice at the surface, so we don't change it here.
-     enddo
-   endif ! not found
-ENDDO ! islope
-
-write(*,*) 'PEMETAT0: THERMAL INERTIA DONE'
+    do islope = 1,nslope
+        write(num,'(i2.2)') islope
+        call get_field("TI_PEM_slope"//num,TI_startPEM(:,:,islope),found)
+        if (.not. found) then
+            write(*,*)'PEM settings: failed loading <TI_PEM_slope'//num//'>'
+            write(*,*)'will reconstruct the values of TI_PEM'
+
+            do ig = 1,ngrid
+                if (TI_PEM(ig,index_breccia,islope) < TI_breccia) then
+                    !!! transition
+                    delta = depth_breccia
+                    TI_PEM(ig,index_breccia+1,islope) = sqrt((layer_PEM(index_breccia + 1) - layer_PEM(index_breccia))/ &
+                                                        (((delta - layer_PEM(index_breccia))/(TI_PEM(ig,index_breccia,islope)**2)) + &
+                                                        ((layer_PEM(index_breccia + 1) - delta)/(TI_breccia**2))))
+                    do iloop=index_breccia+2,index_bedrock
+                        TI_PEM(ig,iloop,islope) = TI_breccia
+                    enddo
+                else ! we keep the high ti values
+                    do iloop = index_breccia + 1,index_bedrock
+                        TI_PEM(ig,iloop,islope) = TI_PEM(ig,index_breccia,islope)
+                    enddo
+                endif ! TI PEM and breccia comparison
+                !! transition
+                delta = depth_bedrock
+                TI_PEM(ig,index_bedrock + 1,islope) = sqrt((layer_PEM(index_bedrock + 1) - layer_PEM(index_bedrock))/ &
+                                                        (((delta - layer_PEM(index_bedrock))/(TI_PEM(ig,index_bedrock,islope)**2)) + &
+                                                        ((layer_PEM(index_bedrock + 1) - delta)/(TI_bedrock**2))))
+                do iloop = index_bedrock + 2,nsoil_PEM
+                    TI_PEM(ig,iloop,islope) = TI_bedrock
+                enddo
+            enddo
+        else ! found
+            do iloop = nsoil_GCM + 1,nsoil_PEM
+                TI_PEM(:,iloop,islope) = TI_startPEM(:,iloop,islope)  ! ! 1st layers can change because of the presence of ice at the surface, so we don't change it here.
+            enddo
+        endif ! not found
+    enddo ! islope
+
+    write(*,*) 'PEMETAT0: THERMAL INERTIA doNE'
 
 ! b. Special case for inertiedat, inertiedat_PEM
@@ -154,14 +162,14 @@
  do iloop = 1,nsoil_GCM
    inertiedat_PEM(:,iloop) = inertiedat(:,iloop)
- enddo 
+ enddo
 !!! zone de transition
 delta = depth_breccia
 do ig = 1,ngrid
-if(inertiedat_PEM(ig,index_breccia).lt.TI_breccia) then 
+if(inertiedat_PEM(ig,index_breccia).lt.TI_breccia) then
 inertiedat_PEM(ig,index_breccia+1) = sqrt((layer_PEM(index_breccia+1)-layer_PEM(index_breccia))/ &
             (((delta-layer_PEM(index_breccia))/(inertiedat(ig,index_breccia)**2))+ &
                       ((layer_PEM(index_breccia+1)-delta)/(TI_breccia**2))))
 
- do iloop = index_breccia+2,index_bedrock 
+ do iloop = index_breccia+2,index_bedrock
        inertiedat_PEM(ig,iloop) = TI_breccia
   enddo
@@ -170,5 +178,5 @@
    do iloop=index_breccia+1,index_bedrock
       inertiedat_PEM(ig,iloop) = inertiedat_PEM(ig,nsoil_GCM)
-   enddo 
+   enddo
 endif ! comparison ti breccia
 enddo!ig
@@ -189,7 +197,7 @@
 endif ! not found
 
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 !2. Soil Temperature
-DO islope=1,nslope
+do islope=1,nslope
   write(num,fmt='(i2.2)') islope
    call get_field("tsoil_PEM_slope"//num,tsoil_startPEM(:,:,islope),found)
@@ -199,5 +207,5 @@
 !      do ig = 1,ngrid
 !        kcond = (TI_PEM(ig,index_breccia+1,islope)*TI_PEM(ig,index_breccia+1,islope))/volcapa
-!        tsoil_PEM(ig,index_breccia+1,islope) = tsoil_PEM(ig,index_breccia,islope) + fluxgeo/kcond*(mlayer_PEM(index_breccia)-mlayer_PEM(index_breccia-1))   
+!        tsoil_PEM(ig,index_breccia+1,islope) = tsoil_PEM(ig,index_breccia,islope) + fluxgeo/kcond*(mlayer_PEM(index_breccia)-mlayer_PEM(index_breccia-1))
 !       do iloop=index_breccia+2,index_bedrock
 !            kcond = (TI_PEM(ig,iloop,islope)*TI_PEM(ig,iloop,islope))/volcapa
@@ -205,5 +213,5 @@
 !      enddo
 !        kcond = (TI_PEM(ig,index_bedrock+1,islope)*TI_PEM(ig,index_bedrock+1,islope))/volcapa
-!        tsoil_PEM(ig,index_bedrock+1,islope) = tsoil_PEM(ig,index_bedrock,islope) + fluxgeo/kcond*(mlayer_PEM(index_bedrock)-mlayer_PEM(index_bedrock-1))  
+!        tsoil_PEM(ig,index_bedrock+1,islope) = tsoil_PEM(ig,index_bedrock,islope) + fluxgeo/kcond*(mlayer_PEM(index_bedrock)-mlayer_PEM(index_bedrock-1))
 !
 !      do iloop=index_bedrock+2,nsoil_PEM
@@ -215,7 +223,7 @@
 
      call soil_pem_ini(ngrid,nsoil_PEM,TI_PEM(:,:,islope),tsurf_ave_yr2(:,islope),tsoil_PEM(:,:,islope))
-     call soil_pem_routine(ngrid,nsoil_PEM,.true.,TI_PEM(:,:,islope),timestep,tsurf_ave_yr2(:,islope),tsoil_PEM(:,:,islope))
-
-    
+     call soil_pem_compute(ngrid,nsoil_PEM,.true.,TI_PEM(:,:,islope),timestep,tsurf_ave_yr2(:,islope),tsoil_PEM(:,:,islope))
+
+
    else
 ! predictor corrector: restart from year 1 of the GCM and build the evolution of
@@ -223,8 +231,8 @@
 
     tsoil_tmp_yr1(:,:,islope) = tsoil_startPEM(:,:,islope)
-    call soil_pem_routine(ngrid,nsoil_PEM,.true.,TI_PEM(:,:,islope),timestep,tsurf_ave_yr1(:,islope),tsoil_tmp_yr1(:,:,islope))
-    call soil_pem_routine(ngrid,nsoil_PEM,.false.,TI_PEM(:,:,islope),timestep,tsurf_ave_yr1(:,islope),tsoil_tmp_yr1(:,:,islope))
-    tsoil_tmp_yr2(:,:,islope) = tsoil_tmp_yr1(:,:,islope)     
-    call soil_pem_routine(ngrid,nsoil_PEM,.true.,TI_PEM(:,:,islope),timestep,tsurf_ave_yr2(:,islope),tsoil_tmp_yr2(:,:,islope))
+    call soil_pem_compute(ngrid,nsoil_PEM,.true.,TI_PEM(:,:,islope),timestep,tsurf_ave_yr1(:,islope),tsoil_tmp_yr1(:,:,islope))
+    call soil_pem_compute(ngrid,nsoil_PEM,.false.,TI_PEM(:,:,islope),timestep,tsurf_ave_yr1(:,islope),tsoil_tmp_yr1(:,:,islope))
+    tsoil_tmp_yr2(:,:,islope) = tsoil_tmp_yr1(:,:,islope)
+    call soil_pem_compute(ngrid,nsoil_PEM,.true.,TI_PEM(:,:,islope),timestep,tsurf_ave_yr2(:,islope),tsoil_tmp_yr2(:,:,islope))
 
 
@@ -244,9 +252,9 @@
         enddo
       enddo
-ENDDO ! islope
-
-write(*,*) 'PEMETAT0: SOIL TEMP  DONE'
-
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+enddo ! islope
+
+write(*,*) 'PEMETAT0: SOIL TEMP  doNE'
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 !3. Ice Table
   call get_field("ice_table",ice_table,found)
@@ -261,10 +269,10 @@
    endif
 
-write(*,*) 'PEMETAT0: ICE TABLE  DONE'
-
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+write(*,*) 'PEMETAT0: ICE TABLE  doNE'
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 !4. CO2 & H2O Adsorption
  if(adsorption_pem) then
-  DO islope=1,nslope
+  do islope=1,nslope
    write(num,fmt='(i2.2)') islope
    call get_field("mco2_reg_ads_slope"//num,m_co2_regolith_phys(:,:,islope),found)
@@ -273,8 +281,8 @@
        exit
     endif
-    
-  ENDDO
-
-  DO islope=1,nslope
+
+  enddo
+
+  do islope=1,nslope
    write(num,fmt='(i2.2)') islope
    call get_field("mh2o_reg_ads_slope"//num,m_h2o_regolith_phys(:,:,islope),found2)
@@ -283,6 +291,6 @@
       exit
     endif
-    
-  ENDDO
+
+  enddo
 
     call regolith_adsorption(ngrid,nslope,nsoil_PEM,timelen,tend_h2oglaciers,tend_co2glaciers,waterice,co2ice,tsoil_PEM,TI_PEM,ps_inst,q_co2,q_h2o, &
@@ -293,13 +301,13 @@
     endif
     if((.not.found2)) then
-       deltam_h2o_regolith_phys(:) = 0.  
+       deltam_h2o_regolith_phys(:) = 0.
     endif
-write(*,*) 'PEMETAT0: CO2 & H2O adsorption DONE'
+write(*,*) 'PEMETAT0: CO2 & H2O adsorption doNE'
     endif
 endif ! soil_pem
 
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 !. 5 water reservoir
-#ifndef CPP_STD   
+#ifndef CPP_STD
    call get_field("water_reservoir",water_reservoir,found)
    if(.not.found) then
@@ -326,5 +334,5 @@
       do ig = 1,ngrid
 
-          if(TI_PEM(ig,index_breccia,islope).lt.TI_breccia) then 
+          if(TI_PEM(ig,index_breccia,islope).lt.TI_breccia) then
 !!! transition
              delta = depth_breccia
@@ -335,9 +343,9 @@
           do iloop=index_breccia+2,index_bedrock
             TI_PEM(ig,iloop,islope) = TI_breccia
-         enddo      
+         enddo
          else ! we keep the high ti values
            do iloop=index_breccia+1,index_bedrock
                   TI_PEM(ig,iloop,islope) = TI_PEM(ig,index_breccia,islope)
-           enddo 
+           enddo
          endif
 
@@ -349,5 +357,5 @@
           do iloop=index_bedrock+2,nsoil_PEM
             TI_PEM(ig,iloop,islope) = TI_bedrock
-         enddo   
+         enddo
       enddo
 enddo
@@ -357,7 +365,7 @@
  enddo
 !!! zone de transition
-delta = depth_breccia 
+delta = depth_breccia
 do ig = 1,ngrid
-      if(inertiedat_PEM(ig,index_breccia).lt.TI_breccia) then 
+      if(inertiedat_PEM(ig,index_breccia).lt.TI_breccia) then
 inertiedat_PEM(ig,index_breccia+1) = sqrt((layer_PEM(index_breccia+1)-layer_PEM(index_breccia))/ &
             (((delta-layer_PEM(index_breccia))/(inertiedat(ig,index_breccia)**2))+ &
@@ -365,11 +373,11 @@
 
 
- do iloop = index_breccia+2,index_bedrock 
+ do iloop = index_breccia+2,index_bedrock
 
        inertiedat_PEM(ig,iloop) = TI_breccia
-   
+
  enddo
-else 
-   do iloop = index_breccia+1,index_bedrock 
+else
+   do iloop = index_breccia+1,index_bedrock
        inertiedat_PEM(ig,iloop) = inertiedat_PEM(ig,index_breccia)
     enddo
@@ -394,8 +402,8 @@
  enddo
 
-write(*,*) 'PEMETAT0: TI DONE'
-
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-!b) Soil temperature 
+write(*,*) 'PEMETAT0: TI doNE'
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!b) Soil temperature
     do islope = 1,nslope
 !     do ig = 1,ngrid
@@ -414,11 +422,11 @@
 !            tsoil_PEM(ig,iloop,islope) = tsoil_PEM(ig,index_bedrock+1,islope) + fluxgeo/kcond*(mlayer_PEM(iloop-1)-mlayer_PEM(index_bedrock))
 !      enddo
-     
+
 !       enddo
 
       call soil_pem_ini(ngrid,nsoil_PEM,TI_PEM(:,:,islope),tsurf_ave_yr2(:,islope),tsoil_PEM(:,:,islope))
-      call soil_pem_routine(ngrid,nsoil_PEM,.true.,TI_PEM(:,:,islope),timestep,tsurf_ave_yr2(:,islope),tsoil_PEM(:,:,islope))
-
-   
+      call soil_pem_compute(ngrid,nsoil_PEM,.true.,TI_PEM(:,:,islope),timestep,tsurf_ave_yr2(:,islope),tsoil_PEM(:,:,islope))
+
+
     do it = 1,timelen
         do isoil = nsoil_GCM+1,nsoil_PEM
@@ -433,7 +441,7 @@
         enddo
 enddo !islope
-write(*,*) 'PEMETAT0: TSOIL DONE'
-
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+write(*,*) 'PEMETAT0: TSOIL doNE'
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 !c) Ice table
        call computeice_table_equilibrium(ngrid,nslope,nsoil_PEM,watercaptag,watersurf_ave,watersoil_ave,TI_PEM(:,1,:),ice_table,ice_table_thickness)
@@ -442,46 +450,48 @@
          call soil_pem_ini(ngrid,nsoil_PEM,TI_PEM(:,:,islope),tsurf_ave_yr2(:,islope),tsoil_PEM(:,:,islope))
        enddo
-       write(*,*) 'PEMETAT0: Ice table DONE'
-
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+       write(*,*) 'PEMETAT0: Ice table doNE'
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 !d) Regolith adsorbed
- if(adsorption_pem) then
+if (adsorption_pem) then
     m_co2_regolith_phys(:,:,:) = 0.
     m_h2o_regolith_phys(:,:,:) = 0.
 
     call regolith_adsorption(ngrid,nslope,nsoil_PEM,timelen,tend_h2oglaciers,tend_co2glaciers,waterice,co2ice,tsoil_PEM,TI_PEM,ps_inst,q_co2,q_h2o, &
-                                m_h2o_regolith_phys,deltam_h2o_regolith_phys, m_co2_regolith_phys,deltam_co2_regolith_phys)
-   
+                             m_h2o_regolith_phys,deltam_h2o_regolith_phys, m_co2_regolith_phys,deltam_co2_regolith_phys)
+
     deltam_co2_regolith_phys(:) = 0.
-    deltam_h2o_regolith_phys(:) = 0.  
- endif
-
-write(*,*) 'PEMETAT0: CO2 adsorption DONE'
+    deltam_h2o_regolith_phys(:) = 0.
+endif
+
+write(*,*) 'PEMETAT0: CO2 adsorption doNE'
 endif !soil_pem
 
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 !. e) water reservoir
-#ifndef CPP_STD   
-      do ig=1,ngrid
-        if(watercaptag(ig)) then
-           water_reservoir(ig)=water_reservoir_nom
+#ifndef CPP_STD
+    do ig = 1,ngrid
+        if (watercaptag(ig)) then
+            water_reservoir(ig) = water_reservoir_nom
         else
-           water_reservoir(ig)=0.
+            water_reservoir(ig) = 0.
         endif
-      enddo
+    enddo
 #endif
 
 endif ! of if (startphy_file)
 
-if(soil_pem) then
-!! Sanity check
-    DO ig = 1,ngrid
-      DO islope = 1,nslope
-        DO iloop = 1,nsoil_PEM
-          if (isnan(tsoil_PEM(ig,iloop,islope))) call abort_pem("PEM - pemetat0","NaN detected in Tsoil",1) 
-        ENDDO
-      ENDDO
-     ENDDO
-endif!soil_pem
-
-END SUBROUTINE
+if (soil_pem) then ! Sanity check
+    do ig = 1,ngrid
+        do islope = 1,nslope
+            do iloop = 1,nsoil_PEM
+                if (isnan(tsoil_PEM(ig,iloop,islope))) call abort_pem("PEM - pemetat0","NaN detected in Tsoil",1)
+            enddo
+        enddo
+    enddo
+endif !soil_pem
+
+END SUBROUTINE pemetat0
+
+END MODULE pemetat0_mod
+
